import 'dart:collection';

import 'providers.dart';

class MiodiModule {
  final HashMap<Type, Provider> moduleConfiguration = HashMap();
  final HashMap<String, Map<Type, ScopeProvider>> scopeConfiguration = HashMap();
  List<Provider> providers;

  MiodiModule(this.providers) {
    providers.forEach((provider) {
      var isScopeProvider = provider is ScopeProvider;
      if (!isScopeProvider)
        moduleConfiguration[provider.provideType] = provider;
      else {
        ScopeProvider scopeProvider = provider as ScopeProvider;
        if (scopeConfiguration.containsKey(scopeProvider.scope)) {
          scopeConfiguration[scopeProvider.scope][scopeProvider.provideType] = scopeProvider;
        } else scopeConfiguration[scopeProvider.scope] = {scopeProvider.provideType: scopeProvider};
      }
    });
  }
}