class BadComponentNamespaceException implements Exception {
  final String componentNamespace;
  BadComponentNamespaceException(this.componentNamespace);

  @override
  String toString() {
    return 'BadComponentNamespaceException: You did not initialize "$componentNamespace" namespace.';
  }
}

class NotFoundProviderException implements Exception {
  final Type type;
  final String namespace;
  NotFoundProviderException(this.type, [this.namespace]);

  @override
  String toString() {
    if (namespace != null) {
      return 'NotFoundProviderException: You have not created a provider that returns "$type" in "$namespace" namespace.';
    }
    return 'NotFoundProviderException: You have not created a provider that returns "$type".';
  }
}

class BadScopeNameException implements Exception {
  final String scope;
  BadScopeNameException(this.scope);

  @override
  String toString() {
    return 'BadScopeNameException: You did not initialize "$scope" scope.';
  }
}

class NotInitializeMiodiException implements Exception {
  @override
  String toString() {
    return 'NotInitializeMiodiException: You must initialize Miodi before usages "inject()" or "injectAsync()". Call "Miodi.init(components)" when your application start.';
  }
}